#include <vtkSmartPointer.h>
#include <vtkPolyData.h>
#include <vtkActor.h>
#include <vtkPointPicker.h>
#include <vtkInteractorStyleTrackballCamera.h>
#include <vtkRenderWindowInteractor.h>
#include <vtkObjectFactory.h>
#include <vtkRenderer.h>
#include <vtkRenderWindow.h>

/*! \class MouseInteractorStylePP visualization.h "visualization.h"
 *  \brief This is implemention of interaction style.
 *
 *  \extends vtkInteractorStyleTrackballCamera
 * 
 *  In this class is implemented our interaction style.
 *  Extends form vtkInteractorStyleTrackballCamera class.
*/
class MouseInteractorStylePP : public vtkInteractorStyleTrackballCamera
{
	private:
		vtkSmartPointer<vtkPolyData> pdcage, pdfigure;
		vtkIdType picked_point_down_id;
		vtkSmartPointer<vtkActor> picked_actor_down;
		vtkSmartPointer<vtkActor> cage_ref;
		float *mvcoords;
		struct cl_data *clData;
		unsigned int clicked; 

	public:
		static MouseInteractorStylePP* New();
		vtkTypeMacro(MouseInteractorStylePP, vtkInteractorStyleTrackballCamera);
		
		MouseInteractorStylePP();

		void SetPolyDataCage (vtkSmartPointer<vtkPolyData> pd);

		void SetPolyDataFigure (vtkSmartPointer<vtkPolyData> pd);

		void SetCageRef (vtkSmartPointer<vtkActor> ref);

		void SetMeanValueCoords (float *v);

		void SetClData (struct cl_data *d);

		virtual void OnMiddleButtonDown();

		virtual void OnMiddleButtonUp();
		
		virtual void OnMouseMove();
};
