/*! \file main.cpp
 *  \brief Main file
 *  \author Albert Busqué
 * 
 * This file contains the function main.
 */

#include <unistd.h>
#include "visualization.h"

static const char *optString = "m:c:";

int main (int argc, char **argv)
{
	int opt;
	struct global_args args = {NULL, NULL};
	
	// Show the usage if necessary
	if (argc < 2) 
	{
		printf("Use: %s -m <model_filename> [-c <cage_filename>]\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	// Parse arguments
	opt = getopt( argc, argv, optString );
    	while( opt != -1 ) 
	{
     		switch( opt ) 
		{
            		case 'm':
                		args.figure_filename = optarg; /* true */
                		break;
                
            		case 'c':
                		args.cage_filename = optarg;
                		break;
                                
            		default:
               			 /* You won't actually get here. */
                		break;
        	}
        
        	opt = getopt( argc, argv, optString );
    	}	
	
	if (!args.figure_filename)
	{
		printf("Use: %s -m <model_filename> [-c <cage_filename>]\n", argv[0]);
		exit(EXIT_FAILURE);
	}
	
	// Start loading and visualization	
	visualize (args);

	return EXIT_SUCCESS;	
}
