#include <CL/cl.h>
#include "meanvalue.h"

#define OPENCL

extern const char *kernel_src;

struct cl_data
{
	cl_uint numPlatforms; 
	cl_platform_id *platforms;
	cl_uint numDevices;
	cl_device_id *devices;
	cl_context context;
	cl_command_queue cmdQueue;
	cl_mem bufferMV;  		// Input array on the device
	cl_mem bufferCage;  		// Input array on the device
	cl_mem bufferU;  		// Input array on the device
	cl_mem bufferDist;  		// Input array on the device
	cl_mem bufferFigure; 
	cl_mem bufferFaces;
	cl_program program;
	cl_kernel kernel;
	size_t globalWorkSize[1];
	
};

void chk (cl_int status, const char* cmd);
void init_opencl_resources (struct cl_data *data);
void compute_parallel_coordinates (struct cl_data *clData, Cage *cage, unsigned int fig_npts, float *figure_points, float *mvcoords);
void recover_parallel_point (struct cl_data *clData, float *cage_points, unsigned int cage_npts, unsigned int fig_npts, float *figure_points);
