/*! \file visualization.h
 *  \brief This file contains the header of visualization.cpp 
 *  \author Albert Busqué
 */

#include <vtkVersion.h>
#include <vtkSmartPointer.h>
#include <vtkTriangle.h>
#include <vtkCellArray.h>
#include <vtkPolyData.h>
#include <vtkPolyDataMapper.h>
#include <vtkActor.h>
#include <vtkRenderWindow.h>
#include <vtkRenderer.h>
#include <vtkRenderWindowInteractor.h>
#include <vtkPointPicker.h>
#include <vtkInteractorStyleTrackballCamera.h>
#include <vtkObjectFactory.h>
#include <vtkPLYReader.h>
#include <vtkOBJReader.h>

#include "meanvalue.h"

struct global_args {
    char *cage_filename;             /* -c option */
    char *figure_filename;          /* -f option */
};

void visualize ( struct global_args args);
void create_polydata_cube_cage (vtkSmartPointer<vtkActor> fig, vtkSmartPointer<vtkPolyData> polydata);
void create_cage_from_polydata (vtkSmartPointer<vtkPolyData> polydata, Cage *c);
void read_model_from_file (char* filename, vtkSmartPointer<vtkPolyDataMapper> mapper);
